(PackageInfo named: 'Relationships') postscriptOfRemoval: '"below, add code to clean up after the unloading of this package"
Class removeInstVarName: ''relationships''.'!
(PackageInfo named: 'Relationships') preamble: '"below, add code to be run before the loading of this package"
| relationship |
relationship := ''relationships''.
(Class instVarNames contains: [:each | (each = relationship)] )
	ifFalse: [Class addInstVarName: relationship]. '!
SystemOrganization addCategory: #'Relationships-Tests'!
SystemOrganization addCategory: #Relationships!
SystemOrganization addCategory: #'Relationships-ArtworkExamples'!

Browser subclass: #RelationshipBrowser
	instanceVariableNames: 'relationshipsIndicated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships'!

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 1/13/2011 11:04:26.856'!
aboutToStyle: aStyler
	"This is a notification that aStyler is about to re-style its text.
	Set the classOrMetaClass in aStyler, so that identifiers
	will be resolved correctly.
	Answer true to allow styling to proceed, or false to veto the styling"
	self relationshipsIndicated ifTrue: 
		[aStyler classOrMetaClass: nil.
		^ true].
	^ super aboutToStyle: aStyler.! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 12/27/2010 10:30:55.646'!
buildSwitchesWith: builder
	"Build the instance/comment/class switch"
	| panelSpec buttonSpec |
	panelSpec := builder pluggablePanelSpec new.
	panelSpec children: OrderedCollection new.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'instance'; 
			state: #instanceMessagesIndicated; 
			action: #indicateInstanceMessages;
			frame: (0@0 corner: 0.39@1).
	panelSpec children addLast: buttonSpec.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: '?'; 
			state: #classCommentIndicated; 
			action: #plusButtonHit;
			frame: (0.41@0 corner: 0.59@1).
	panelSpec children addLast: buttonSpec.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'class'; 
			state: #classMessagesIndicated; 
			action: #indicateClassMessages;
			frame: (0.61@0 corner: 0.79@1).
	panelSpec children addLast: buttonSpec.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: '-->'; 
			state: #relationshipsIndicated; 
			action: #indicateRelationships;
			frame: (0.81@0 corner: 1@1).
	panelSpec children addLast: buttonSpec.

	^panelSpec! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 12/27/2010 11:13:48.379'!
classMessagesIndicated
	self relationshipsIndicated 
		ifTrue: [^ false]
		ifFalse: [^ super classMessagesIndicated].! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 1/17/2011 10:52:43.832'!
contents
	| |
	relationshipsIndicated ifFalse: 
		[^ super contents].
	self selectedMessageName ifNotNil: [^ self selectedRelationship definition].
	(messageCategoryListIndex = 2) ifTrue: 
			"One to One"
			[^ OneToOneRelationship emptyDefinitionWithLeftClassString: (self selectedClass name)].
	(messageCategoryListIndex = 3) ifTrue: 
			"One to Many"
			[^ OneToManyRelationship emptyDefinitionWithLeftClassString: (self selectedClass name)].
	(messageCategoryListIndex = 4) ifTrue: 
			"Many to One"
			[^ OneToManyRelationship emptyDefinitionWithRightClassString: (self selectedClass name)].
	(messageCategoryListIndex = 5) ifTrue: 
			"Many to Many"
			[^ ManyToManyRelationship emptyDefinitionWithLeftClassString: (self selectedClass name)].
	self selectedClass ifNotNil: 
		[^ OneToManyRelationship emptyDefinitionWithLeftClassString: (self selectedClass name)].
	^ OneToManyRelationship emptyDefinition.! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 1/29/2011 18:54:30.66'!
contents: input notifying: aController 
	"Save the contents"
	| relationship |
	relationshipsIndicated ifFalse: 
		[^ super contents: input notifying: aController.].
	self selectedRelationship ifNotNil: [self selectedRelationship remove.].
	relationship := Compiler evaluate: input "notifying: aController logged: false".
	relationship activate.
	self clearUserEditFlag.
	self selectedMessageName: (self selectedClass keyForRelationship: relationship).
	self changed: #messageList.! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 12/27/2010 10:27:53.29'!
defaultBrowserTitle
	^ 'Relationship Browser'! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 12/27/2010 11:23:59.754'!
indicateRelationships
	relationshipsIndicated := true.
	self changed: #classSelectionChanged.
	self changed: #messageCategoryList.
	self changed: #messageList.
	self changed: #contents.
	self changed: #annotation.
	self decorateButtons.
	^ relationshipsIndicated.! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 12/27/2010 11:13:42.409'!
instanceMessagesIndicated
	self relationshipsIndicated 
		ifTrue: [^ false]
		ifFalse: [^ super instanceMessagesIndicated].! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 3/7/2011 17:00:22.267'!
messageCategoryList
	"Answer the selected category of messages."
	relationshipsIndicated ifFalse: 
		[^ super messageCategoryList].
	classListIndex = 0
		ifTrue: 
			[^ Array new]
		ifFalse: 
			[^ #('-- all --' 'OneToOne' 'OneToMany' 'ManyToOne' 'ManyToMany') ].! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 1/29/2011 18:27:21.284'!
messageList
	"Answer the selected category of messages."
	| collection |
	relationshipsIndicated ifFalse: 
		[^ super messageList].
	collection := OrderedCollection new.
	(messageCategoryListIndex = 0) | (messageCategoryListIndex = 1)
		ifTrue: 
			"No selection or all"
			[self selectedClass ifNotNil: [^ self selectedClass relationships keys copy].
			^ collection asArray.]
		ifFalse: 
			[
			"One to one"
			(messageCategoryListIndex = 2) ifTrue: 
				[self selectedClass relationships do: 
					[ :each | each isOneToOneRelationship ifTrue: 
						[collection add: (self selectedClass keyForRelationship: each)]
					].
				].
			"One to many"
			(messageCategoryListIndex = 3) ifTrue: 
				[self selectedClass relationships do: 
					[ :each | each isOneToManyRelationship ifTrue: 
						[each leftClass = self selectedClass ifTrue: 
							[collection add: (self selectedClass keyForRelationship: each)]
						] 
					].
				].
			"Many to one"
			(messageCategoryListIndex = 4) ifTrue: 
				[self selectedClass relationships do: 
					[ :each | each isOneToManyRelationship ifTrue: 
						[each rightClass = self selectedClass ifTrue: 
							[collection add: (self selectedClass keyForRelationship: each)]
						] 
					].
				].
			"Many to many"
			(messageCategoryListIndex = 5) ifTrue: 
				[self selectedClass relationships do: 
					[ :each | each isManyToManyRelationship ifTrue: 
						[collection add: (self selectedClass keyForRelationship: each)]
					].
				].
			^ collection asArray.
			].! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 12/27/2010 11:25:27.859'!
metaClassIndicated: trueOrFalse
	"Is called both for instance and class indication. Unset the relationship indicator."
	relationshipsIndicated := false.
	^ super metaClassIndicated: trueOrFalse.! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 12/24/2010 00:03:22.31'!
relationshipsIndicated
	relationshipsIndicated ifNil: [relationshipsIndicated := false].
	^ relationshipsIndicated.! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 3/7/2011 17:00:41.755'!
removeMessage
	"Remove a relationship"
	self relationshipsIndicated ifFalse: [^ super removeMessage].
	messageListIndex = 0
		ifTrue: [^ self].
	self okToChange
		ifFalse: [^ self].
	self selectedRelationship remove.
	self messageListIndex: 0.
	self changed: #messageList.
	self setClassOrganizer.! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 1/3/2011 14:59:27.95'!
selectedRelationship
	"return the selected relationship"
	self selectedMessageName ifNil: [^ nil].
	^ self selectedClass relationships at: self selectedMessageName.! !

Object subclass: #Artist
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-ArtworkExamples'!

!Artist class methodsFor: 'as yet unclassified' stamp: 'cn 1/29/2011 19:52:03.12'!
name: aString
	^ (self new) name: aString.! !

!Artist methodsFor: 'accessing' stamp: 'cn 1/29/2011 19:41:46.437'!
name
	^ name.! !

!Artist methodsFor: 'accessing' stamp: 'cn 1/29/2011 19:41:29.95'!
name: anObject
	"Set the value of name"

	name := anObject! !

!Artist methodsFor: 'print' stamp: 'cn 1/29/2011 19:57:18.432'!
print
	| string |
	string := name, ' has created: 
'.
	self artworks do: [:each | string := string, each name, '
'].
	Transcript show: string.! !

Object subclass: #Artwork
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-ArtworkExamples'!

!Artwork class methodsFor: 'as yet unclassified' stamp: 'cn 1/29/2011 19:51:56.149'!
name: aString
	^ (self new) name: aString.! !

!Artwork methodsFor: 'accessing' stamp: 'cn 1/29/2011 19:42:06.076'!
name
	^ name.! !

!Artwork methodsFor: 'accessing' stamp: 'cn 1/29/2011 19:41:59.848'!
name: aString
	name := aString.! !

!Artwork methodsFor: 'print' stamp: 'cn 1/29/2011 19:55:06.694'!
print
	Transcript show: 'Artwork ', name, ' was created by: ', self artist name, '
'.! !

Object subclass: #Auction
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-ArtworkExamples'!

!Auction class methodsFor: 'as yet unclassified' stamp: 'cn 2/2/2011 14:14:53.747'!
name: aString
	^ (self new) name: aString.! !

!Auction methodsFor: 'accessing' stamp: 'cn 2/2/2011 14:14:33.228'!
name 
	^ name.! !

!Auction methodsFor: 'accessing' stamp: 'cn 2/2/2011 14:14:23.335'!
name: aString
	name := aString.! !

!Auction methodsFor: 'print' stamp: 'cn 2/2/2011 14:21:09.079'!
print
	| string |
	string := 'Auction ', name, ' sells these artworks: '.
	self artworks do: [:each | string := string , each name, ' '.].
	Transcript show: string, '
'.! !

Object subclass: #Child
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Tests'!

Object subclass: #Estimate
	instanceVariableNames: 'price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-ArtworkExamples'!

Object subclass: #Parent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Tests'!

Object subclass: #RelationshipDescription
	instanceVariableNames: 'leftClass leftClassName rightClass rightClassName isBidirectional isActive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships'!

RelationshipDescription subclass: #ManyToManyRelationship
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships'!

!ManyToManyRelationship methodsFor: 'generating' stamp: 'cn 1/29/2011 11:54:35.915'!
generateGetterLeftClass
	| template |
	"Getter"
	template := RelationshipDescription getterCollectionTemplate.
	template
		methodName: self getterNameLeftClass;
		instVarName: self instVarNameLeftClass.
	leftClass compile: template apply classified: #accessing! !

!ManyToManyRelationship methodsFor: 'generating' stamp: 'cn 1/29/2011 11:54:58.174'!
generateGetterRightClass
	| template |
	"Getter"
	template := RelationshipDescription getterCollectionTemplate.
	template
		methodName: self getterNameRightClass;
		instVarName: self instVarNameRightClass.
	rightClass compile: template apply classified: #accessing! !

!ManyToManyRelationship methodsFor: 'generating' stamp: 'cn 1/29/2011 11:48:37.577'!
generateInstVarLeftClass
	"Generates the instance variable."
	self generateInstVar: self instVarNameLeftClass inClass: leftClass.! !

!ManyToManyRelationship methodsFor: 'generating' stamp: 'cn 1/29/2011 11:48:46.568'!
generateInstVarRightClass
	"Generates the instance variable."
	self generateInstVar: self instVarNameRightClass inClass: rightClass.! !

!ManyToManyRelationship methodsFor: 'generating' stamp: 'cn 1/29/2011 14:12:16.593'!
generateMethodsLeftClass
	self generateGetterLeftClass;
		generateSetterLeftClass;
		generateRemoveLeftClass.! !

!ManyToManyRelationship methodsFor: 'generating' stamp: 'cn 1/29/2011 14:12:31.476'!
generateMethodsRightClass
	self generateGetterRightClass.! !

!ManyToManyRelationship methodsFor: 'generating' stamp: 'cn 1/29/2011 14:27:58.193'!
generateRemoveLeftClass
	| template |
	"Setter"
	template := Template new
		template: '{methodName} anObject
			{instVarName} remove: anObject.
			(anObject instVarNamed: ''{rightClassInstVarName}'') remove: self.';
			methodName: self removeNameLeftClass;
			instVarName: self instVarNameLeftClass;
			rightClassInstVarName: self instVarNameRightClass.
	leftClass compile: template apply classified: #accessing! !

!ManyToManyRelationship methodsFor: 'generating' stamp: 'cn 1/29/2011 14:23:46.334'!
generateSetterLeftClass
	| template |
	"Setter"
	template := Template new
		template: '{methodName} anObject
			{instVarName} ifNil: [{instVarName} := OrderedCollection new].
			{instVarName} add: anObject.
			(anObject instVarNamed: ''{rightClassInstVarName}'') ifNil: 
				[anObject instVarNamed: ''{rightClassInstVarName}'' put: OrderedCollection new.].
			(anObject instVarNamed: ''{rightClassInstVarName}'') add: self.';
			methodName: self setterNameLeftClass;
			instVarName: self instVarNameLeftClass;
			rightClassInstVarName: self instVarNameRightClass.
	leftClass compile: template apply classified: #accessing! !

!ManyToManyRelationship methodsFor: 'names' stamp: 'cn 1/29/2011 11:47:00.36'!
getterNameLeftClass
	^ self varNameUsedInLeftClass , 's'.! !

!ManyToManyRelationship methodsFor: 'names' stamp: 'cn 1/29/2011 11:47:07.948'!
getterNameRightClass
	^ self varNameUsedInRightClass , 's'.! !

!ManyToManyRelationship methodsFor: 'names' stamp: 'cn 1/29/2011 11:40:40.157'!
instVarNameLeftClass
	^ self varNameAsInstVar: (self varNameAsMany: self varNameUsedInLeftClass).! !

!ManyToManyRelationship methodsFor: 'names' stamp: 'cn 1/29/2011 11:41:06.015'!
instVarNameRightClass
	^ self varNameAsInstVar: (self varNameAsMany: self varNameUsedInRightClass).! !

!ManyToManyRelationship methodsFor: 'accessing' stamp: 'cn 1/17/2011 10:50:03.269'!
isManyToManyRelationship
	^ true.! !

!ManyToManyRelationship methodsFor: 'removing' stamp: 'cn 1/29/2011 13:09:58.088'!
removeInstVarLeftClass
	"Remove instance var"
	leftClass removeInstVarName: self instVarNameLeftClass.! !

!ManyToManyRelationship methodsFor: 'removing' stamp: 'cn 1/29/2011 13:10:08.006'!
removeInstVarRightClass
	"Remove instance var"
	rightClass removeInstVarName: self instVarNameRightClass.! !

!ManyToManyRelationship methodsFor: 'removing' stamp: 'cn 1/29/2011 13:10:37.492'!
removeMethodsLeftClass
	"Getter"
	leftClass removeSelector: self getterNameLeftClass asSymbol.
	"Setter"
	leftClass removeSelector: self setterNameLeftClass asSymbol.
	"Remove"
	leftClass removeSelector: self removeNameLeftClass asSymbol.! !

!ManyToManyRelationship methodsFor: 'removing' stamp: 'cn 1/29/2011 13:10:46.653'!
removeMethodsRightClass
	"Getter"
	rightClass removeSelector: (self getterNameRightClass asSymbol).! !

!ManyToManyRelationship methodsFor: 'names' stamp: 'cn 1/29/2011 11:47:51.819'!
removeNameLeftClass
	^ 'remove', (self varNameUsedInLeftClass capitalized), ':'.! !

!ManyToManyRelationship methodsFor: 'names' stamp: 'cn 1/29/2011 11:47:35.338'!
setterNameLeftClass
	^ 'add', (self varNameUsedInLeftClass capitalized), ':'.! !

RelationshipDescription subclass: #OneToManyRelationship
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships'!

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/28/2011 21:06:20.967'!
generateInstVarLeftClass
	"Generates the instance variable."
	self generateInstVar: self instVarNameOneClass inClass: leftClass.
	! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/28/2011 21:06:14.388'!
generateInstVarRightClass
	"Generates the instance variable."
	self generateInstVar: self instVarNameManyClass inClass: rightClass.! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/28/2011 20:38:11.416'!
generateMethodsLeftClass
	"Generates the methods. Needs to be called after the instance variable has been created."

	self getterOneClass;
		setterOneClass;
		removeOneClass.! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/28/2011 20:38:31.554'!
generateMethodsRightClass
	"Generates the methods. Needs to be called after the instance variable has been created."
	self getterManyClass.! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/28/2011 21:13:58.381'!
getterManyClass
	| template |
	"Getter"
	template := RelationshipDescription getterReferenceTemplate.
	template
		methodName: self getterNameManyClass;
		instVarName: self instVarNameManyClass.
	rightClass compile: template apply classified: #accessing.! !

!OneToManyRelationship methodsFor: 'names' stamp: 'cn 1/28/2011 20:55:57.855'!
getterNameManyClass
	^ self varNameUsedInRightClass.! !

!OneToManyRelationship methodsFor: 'names' stamp: 'cn 1/28/2011 20:55:17.77'!
getterNameOneClass
	^ self varNameUsedInLeftClass , 's'.! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/29/2011 11:53:35.323'!
getterOneClass
	| template |
	"Getter"
	template := RelationshipDescription getterCollectionTemplate.
	template
		methodName: self getterNameOneClass;
		instVarName: self instVarNameOneClass.
	leftClass compile: template apply classified: #accessing! !

!OneToManyRelationship methodsFor: 'names' stamp: 'cn 1/28/2011 20:15:30.487'!
instVarNameManyClass
	^ self varNameAsInstVar: self varNameUsedInRightClass.! !

!OneToManyRelationship methodsFor: 'names' stamp: 'cn 1/28/2011 20:15:23.224'!
instVarNameOneClass
	^ self varNameAsInstVar: (self varNameAsMany: self varNameUsedInLeftClass).! !

!OneToManyRelationship methodsFor: 'accessing' stamp: 'cn 12/24/2010 00:56:14.233'!
isOneToManyRelationship
	^ true.! !

!OneToManyRelationship methodsFor: 'removing' stamp: 'cn 1/28/2011 20:28:05.935'!
removeInstVarLeftClass
	"Remove instance var"
	leftClass removeInstVarName: self instVarNameOneClass.! !

!OneToManyRelationship methodsFor: 'removing' stamp: 'cn 1/28/2011 20:27:15.35'!
removeInstVarRightClass
	"Remove instance var"
	rightClass removeInstVarName: self instVarNameManyClass.! !

!OneToManyRelationship methodsFor: 'removing' stamp: 'cn 1/28/2011 20:25:23.697'!
removeMethodsLeftClass
	"Getter"
	leftClass removeSelector: self getterNameOneClass asSymbol.
	"Setter"
	leftClass removeSelector: self setterNameOneClass asSymbol.
	"Remove"
	leftClass removeSelector: self removeNameOneClass asSymbol.! !

!OneToManyRelationship methodsFor: 'removing' stamp: 'cn 1/29/2011 11:06:30.415'!
removeMethodsRightClass
	"Getter"
	rightClass removeSelector: (self getterNameManyClass asSymbol).! !

!OneToManyRelationship methodsFor: 'names' stamp: 'cn 1/28/2011 20:55:32.737'!
removeNameOneClass
	^ 'remove', (self varNameUsedInLeftClass capitalized), ':'.! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/13/2011 15:15:54.691'!
removeOneClass
	"Remove"
 	| template |
	template := Template new
		template: '{methodName} anObject
			{instVarName} ifNotNil: [{instVarName} remove: anObject ifAbsent: [^false.] ].
			anObject {getterMethod}  = self ifTrue: [anObject instVarNamed: ''{manyInstVarName}'' put: nil].
			^true.';
			methodName: self removeNameOneClass;
			instVarName: self instVarNameOneClass;
			getterMethod: self getterNameManyClass;
			manyInstVarName: self instVarNameManyClass.
	leftClass compile: template apply classified: #accessing.! !

!OneToManyRelationship methodsFor: 'names' stamp: 'cn 1/28/2011 20:55:24.834'!
setterNameOneClass
	^ 'add', (self varNameUsedInLeftClass capitalized), ':'.! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/13/2011 16:04:16.014'!
setterOneClass
	"Setter"
 	| template |
	template := Template new
		template: '{methodName} anObject
			((anObject {getterManyClass} = nil) or: (anObject {getterManyClass} = self)) ifFalse:
				[anObject {getterManyClass} {removeMethod} anObject].
			{instVarName} ifNil: [{instVarName} := OrderedCollection new].
			{instVarName} add: anObject.
			anObject instVarNamed: ''{manyInstVarName}'' put: self.';
			getterManyClass: self getterNameManyClass;
			removeMethod: self removeNameOneClass;
			methodName: self setterNameOneClass;
			instVarName: self instVarNameOneClass;
			manyInstVarName: self instVarNameManyClass.
		leftClass compile: template apply classified: #accessing.
	! !

RelationshipDescription subclass: #OneToOneRelationship
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships'!

!OneToOneRelationship methodsFor: 'generating' stamp: 'cn 1/28/2011 21:18:13.644'!
generateGetterLeftClass
	| template |
	template := RelationshipDescription getterReferenceTemplate.
	template
		methodName: self getterNameLeftClass;
		instVarName: self instVarNameLeftClass.
	leftClass compile: template apply classified: #accessing.! !

!OneToOneRelationship methodsFor: 'generating' stamp: 'cn 1/28/2011 21:07:43.425'!
generateInstVarLeftClass
	"Generates the instance variable."
	self generateInstVar: self instVarNameLeftClass inClass: leftClass.! !

!OneToOneRelationship methodsFor: 'generating' stamp: 'cn 1/28/2011 21:07:57.199'!
generateInstVarRightClass
	"Generates the instance variable."
	self generateInstVar: self instVarNameRightClass inClass: rightClass.! !

!OneToOneRelationship methodsFor: 'generating' stamp: 'cn 1/29/2011 10:38:34.972'!
generateMethodsLeftClass
	"Generates the methods. Needs to be called after the instance variable has been created."
	self generateGetterLeftClass;
		generateSetterLeftClass.! !

!OneToOneRelationship methodsFor: 'generating' stamp: 'cn 1/28/2011 21:15:57.904'!
generateMethodsRightClass
	"Generates the methods. Needs to be called after the instance variable has been created."
	| template |
	"Getter"
	template := RelationshipDescription getterReferenceTemplate.
	template
		methodName: self getterNameRightClass;
		instVarName: self instVarNameRightClass.
	rightClass compile: template apply classified: #accessing.! !

!OneToOneRelationship methodsFor: 'generating' stamp: 'cn 1/29/2011 11:18:19.211'!
generateSetterLeftClass
	| template |
	template := (Template new) template: '{methodName} anObject
			{instVarName} ifNotNil: [{instVarName} instVarNamed: ''{rightClassInstVarName}'' put: nil.].
			anObject ifNotNil: [
				((anObject {getterRightClass} = nil) or: (anObject {getterRightClass} = self)) ifFalse:
					[anObject {getterRightClass} instVarNamed: ''{instVarName}'' put: nil].
				anObject instVarNamed: ''{rightClassInstVarName}'' put: self.].
			{instVarName} := anObject.'.
	template
		methodName: self setterNameLeftClass;
		getterRightClass: self getterNameRightClass;
		instVarName: self instVarNameLeftClass;
		rightClassInstVarName: self instVarNameRightClass.
	leftClass compile: template apply classified: #accessing.! !

!OneToOneRelationship methodsFor: 'names' stamp: 'cn 1/28/2011 20:58:29.533'!
getterNameLeftClass
	^ self varNameUsedInLeftClass.! !

!OneToOneRelationship methodsFor: 'names' stamp: 'cn 1/28/2011 20:58:53.623'!
getterNameRightClass
	^ self varNameUsedInRightClass.! !

!OneToOneRelationship methodsFor: 'names' stamp: 'cn 1/28/2011 20:57:28.254'!
instVarNameLeftClass
	^ self varNameAsInstVar: self varNameUsedInLeftClass.! !

!OneToOneRelationship methodsFor: 'names' stamp: 'cn 1/28/2011 20:57:15.046'!
instVarNameRightClass
	^ self varNameAsInstVar: self varNameUsedInRightClass.! !

!OneToOneRelationship methodsFor: 'accessing' stamp: 'cn 1/17/2011 10:49:06.953'!
isOneToOneRelationship
	^ true.! !

!OneToOneRelationship methodsFor: 'removing' stamp: 'cn 1/29/2011 11:05:42.806'!
removeInstVarLeftClass
	"Remove instance var"
	leftClass removeInstVarName: self instVarNameLeftClass.! !

!OneToOneRelationship methodsFor: 'removing' stamp: 'cn 1/29/2011 11:04:54.974'!
removeInstVarRightClass
	"Remove instance var"
	rightClass removeInstVarName: self instVarNameRightClass.! !

!OneToOneRelationship methodsFor: 'removing' stamp: 'cn 1/29/2011 11:06:14.581'!
removeMethodsLeftClass
	"Getter"
	leftClass removeSelector: self getterNameLeftClass asSymbol.
	"Setter"
	leftClass removeSelector: self setterNameLeftClass asSymbol.! !

!OneToOneRelationship methodsFor: 'removing' stamp: 'cn 1/29/2011 11:06:53.838'!
removeMethodsRightClass
	"Getter"
	rightClass removeSelector: (self getterNameRightClass asSymbol).! !

!OneToOneRelationship methodsFor: 'names' stamp: 'cn 1/28/2011 20:58:39.808'!
setterNameLeftClass
	^ self varNameUsedInLeftClass, ':'.! !

!RelationshipDescription class methodsFor: 'template' stamp: 'cn 1/29/2011 18:55:23.068'!
definitionTemplate
	| template |
	template := Template new.
	template template: 
	'{relationshipType}
	leftClass: {leftClass}
	leftClassName: {leftClassName}
	rightClass: {rightClass}
	rightClassName: {rightClassName}
	isBidirectional: {isBidirectional}'.
	^ template.! !

!RelationshipDescription class methodsFor: 'definition' stamp: 'cn 1/16/2011 13:20:50.974'!
emptyDefinition
	"Definition of the class as a string"
	^ self emptyDefinitionWithLeftClassString: 'YourClass'.! !

!RelationshipDescription class methodsFor: 'definition' stamp: 'cn 1/29/2011 18:55:37.098'!
emptyDefinitionWithLeftClassString: aString
	"Definition of the class as a string"
	| template |
	template := RelationshipDescription definitionTemplate.
	template relationshipType: self name;
		leftClass: aString;
		leftClassName: 'nil';
		rightClass: 'YourOtherClass';
		rightClassName: 'nil';
		isBidirectional: true asString.
	^ template apply.! !

!RelationshipDescription class methodsFor: 'definition' stamp: 'cn 1/29/2011 18:55:41.919'!
emptyDefinitionWithRightClassString: aString
	"Definition of the class as a string"
	| template |
	template := RelationshipDescription definitionTemplate.
	template relationshipType: self name;
		leftClass: 'YourOtherClass';
		leftClassName: 'nil';
		rightClass: aString;
		rightClassName: 'nil';
		isBidirectional: true asString.
	^ template apply.! !

!RelationshipDescription class methodsFor: 'template' stamp: 'cn 1/29/2011 11:53:09.925'!
getterCollectionTemplate
	"A getter for a collection. The returned collection is a copy to protected the relationship from tampering."
	| template |
	template := (Template new) template:
	'{methodName}
		{instVarName} ifNil: [{instVarName} := OrderedCollection new].
		^ {instVarName} copy'.
	^ template.! !

!RelationshipDescription class methodsFor: 'template' stamp: 'cn 1/28/2011 21:12:36.507'!
getterReferenceTemplate
	"A getter for a reference"
	| template |
	template := (Template new)
		template: '{methodName}
			^{instVarName}.'.
	^ template.! !

!RelationshipDescription class methodsFor: 'instance creation' stamp: 'cn 1/29/2011 19:00:41.302'!
leftClass: leftClass leftClassName: leftName rightClass: rightClass rightClassName: rightName isBidirectional: isBidirectional
	"Create a new relationship"
	| relationship |
	relationship := self new.
	relationship
		leftClass: leftClass;
		leftClassName: leftName;
		rightClass: rightClass;
		rightClassName: rightName;
		isBidirectional: isBidirectional.
	^ relationship.! !

!RelationshipDescription class methodsFor: 'instance creation' stamp: 'cn 1/29/2011 19:02:18.259'!
leftClass: leftClass rightClass: rightClass
	"Create a new relationship"
	| relationship |
	relationship := self leftClass: leftClass rightClass: rightClass isBidirectional: true.
	^ relationship.! !

!RelationshipDescription class methodsFor: 'instance creation' stamp: 'cn 1/29/2011 19:01:50.739'!
leftClass: leftClass rightClass: rightClass isBidirectional: isBidirectional
	"Create a new relationship"
	| relationship |
	relationship := self leftClass: leftClass leftClassName: nil rightClass: rightClass rightClassName: nil isBidirectional: isBidirectional.
	^ relationship.! !

!RelationshipDescription methodsFor: 'generate' stamp: 'cn 2/2/2011 14:53:44.097'!
activate
	isActive := true.
	"generate methods and instance vars"
	self checkIfParametersForActivateAreSet.
	"Add to the classes"
	leftClass addRelationship: self.
	self isBidirectional ifTrue: [rightClass addRelationship: self].
	"Do it!!"
	self 
		generateInstVarLeftClass; 
		generateMethodsLeftClass.
	self isBidirectional ifTrue: [
		self 
			generateInstVarRightClass;
			generateMethodsRightClass].! !

!RelationshipDescription methodsFor: 'private' stamp: 'cn 1/29/2011 19:10:13.396'!
checkIfParametersForActivateAreSet
	leftClass ifNil: [Error new signal].
	rightClass ifNil: [Error new signal].! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/16/2011 12:53:10.612'!
classes
	"Classes that reference this relationship"
	| classes |
	classes := OrderedCollection new.
	classes add: leftClass.
	isBidirectional ifTrue: [classes add: rightClass].
	^ classes.! !

!RelationshipDescription methodsFor: 'definition' stamp: 'cn 1/29/2011 19:10:54.956'!
definition
	"Definition of the class as a string"
	| template |
	template := RelationshipDescription definitionTemplate.
	template relationshipType: self class name;
		leftClass: self leftClass name;
		leftClassName: (self inQuotesIfNotNil: self leftClassName);
		rightClass: self rightClass name;
		rightClassName: (self inQuotesIfNotNil: self rightClassName);
		isBidirectional: self isBidirectional asString.
	^ template apply.! !

!RelationshipDescription methodsFor: 'generating' stamp: 'cn 1/28/2011 21:03:50.483'!
generateInstVar: instVarName inClass: aClass
	"Generates an instance variable."
	(aClass instVarNames contains: [:each | (each = instVarName)] ) ifFalse: 
		[aClass addInstVarName: instVarName].! !

!RelationshipDescription methodsFor: 'private' stamp: 'cn 1/16/2011 13:13:08.013'!
inQuotesIfNotNil: aString
	"Put quotes around the string unless it is nil"
	aString ifNotNil: [^ '''', aString, ''''].
	^ 'nil'.! !

!RelationshipDescription methodsFor: 'initialize-release' stamp: 'cn 2/2/2011 14:58:54.585'!
initialize

	super initialize.
	isActive := false.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/16/2011 12:52:11.127'!
isBidirectional
	"Answer the value of isBidirectional"
	isBidirectional ifNil: [isBidirectional := true].
	^ isBidirectional! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 2/2/2011 14:57:16'!
isBidirectional: anObject
	"Set the value of isBidirectional"
	self preChange.
	isBidirectional := anObject.
	self postChange.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 12/24/2010 00:56:00.857'!
isManyToManyRelationship
	^ false.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 12/24/2010 00:55:46.31'!
isOneToManyRelationship
	^ false.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 12/24/2010 00:55:51.808'!
isOneToOneRelationship
	^ false.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/5/2011 14:48:09.366'!
leftClass
	"Answer the value of leftClass"

	^ leftClass! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 2/2/2011 14:57:12.007'!
leftClass: anObject
	"Set the value of leftClass"
	self preChange.
	leftClass := anObject.
	self postChange.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/5/2011 15:18:13.448'!
leftClassName
	"Answer the name of leftClass that is used to generate the methodnames etc"

	^ leftClassName! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 2/2/2011 14:57:08.569'!
leftClassName: anObject
	"Set the value of leftClassName"
	self preChange.
	leftClassName := anObject.
	self postChange.! !

!RelationshipDescription methodsFor: 'protected' stamp: 'cn 2/2/2011 15:01:05.836'!
postChange
	"Regenerate everything with the updated values."
	isActive ifTrue: [self activate].! !

!RelationshipDescription methodsFor: 'protected' stamp: 'cn 2/2/2011 15:00:44.724'!
preChange
	"Remove everything because something will change (not very effective, i know...)"
	isActive ifTrue: [
		self remove.
		isActive := true.
		].! !

!RelationshipDescription methodsFor: 'remove' stamp: 'cn 2/2/2011 14:53:54.364'!
remove
	isActive := false.
	"Remove methods and instance vars"
	self 
		removeMethodsLeftClass; 
		removeInstVarLeftClass.
	self isBidirectional ifTrue: [
		self 
			removeMethodsRightClass; 
			removeInstVarRightClass].
	"Remove self from relationship dictionary"
	leftClass removeRelationship: self.
	(self isBidirectional and: (leftClass ~= rightClass)) ifTrue: [
		rightClass removeRelationship: self.].! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/5/2011 14:48:09.504'!
rightClass
	"Answer the value of rightClass"

	^ rightClass! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 2/2/2011 14:57:04.891'!
rightClass: anObject
	"Set the value of rightClass"
	self preChange.
	rightClass := anObject.
	self postChange.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/5/2011 15:18:38.335'!
rightClassName
	"Answer the name of rightClass that is used to generate the methodnames etc"

	^ rightClassName! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 2/2/2011 14:56:57.816'!
rightClassName: anObject
	"Set the value of rightClassName"
	self preChange.
	rightClassName := anObject.
	self postChange.! !

!RelationshipDescription methodsFor: 'definition' stamp: 'cn 1/16/2011 13:33:46.55'!
shortDefinition
	| aString |
	self leftClassName ifNil: [aString := self leftClass name.]
		ifNotNil: [aString := self leftClassName, '(', self leftClass name, ')'.].
	self isBidirectional ifTrue: [aString := aString , '<->']
		ifFalse: [aString := aString, '->'].
	self rightClassName ifNil: [aString := aString, self rightClass name.]
		ifNotNil: [aString := aString, self rightClassName, '(', self rightClass name, ')'.].
	^ aString.! !

!RelationshipDescription methodsFor: 'protected' stamp: 'cn 1/28/2011 20:18:07.609'!
varNameAsInstVar: aVarName
	^ 'GENERATEDRELATIONSHIP', aVarName.! !

!RelationshipDescription methodsFor: 'protected' stamp: 'cn 1/28/2011 17:55:53.074'!
varNameAsMany: aVarName
	^ aVarName, 's'.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 2/2/2011 14:27:23.149'!
varNameUsedInLeftClass
	"The name to be used for the instance vars and methods in the left class."
	self rightClassName ifNotNil: 
		"The user has set a name"
		[^ self rightClassName ].
	"Use the class name"
	^ (rightClass name) withFirstCharacterDownshifted.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 2/2/2011 14:27:48.579'!
varNameUsedInRightClass
	"The name to be used for the instance vars and methods in the right class."
	self leftClassName ifNotNil: 
		"The user has set a name"
		[^ self leftClassName ].
	"Use the class name"
	^ (leftClass name) withFirstCharacterDownshifted.! !

Object subclass: #Template
	instanceVariableNames: 'aDictionary string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships'!

!Template class methodsFor: 'as yet unclassified' stamp: 'cn 12/13/2010 14:03:11.839'!
insert: aDictionary into: aString 
	"Replace the keys found in aDictionary in aString with the values from aDictionary"
	^String new: aString size streamContents: [ :result |
		| stream currentChar |
		stream := aString readStream.
		[ (currentChar := stream next) == nil ] whileFalse: [
			currentChar == ${
				ifTrue: [
					result nextPutAll: (
						aDictionary at: (stream upTo: $})
						)]
				ifFalse: [
					currentChar == $\
						ifFalse: [ result nextPut: currentChar ]
						ifTrue: [
							(currentChar := stream next) ifNotNil: [
								result nextPut: currentChar ] ] ] ] ]! !

!Template methodsFor: 'as yet unclassified' stamp: 'cn 12/13/2010 14:13:44.389'!
apply
	^Template insert: aDictionary into: string.! !

!Template methodsFor: 'as yet unclassified' stamp: 'cn 12/13/2010 14:07:12.157'!
at: key put: value
	aDictionary ifNil: [aDictionary := Dictionary new.].
	aDictionary at: key put: value.! !

!Template methodsFor: 'as yet unclassified' stamp: 'cn 1/5/2011 13:37:25.49'!
doesNotUnderstand: aMessage
	"Implement a short notation that allows to fill the dictionary in a nicer fashion
	Old way: 	aTemplate at: 'value' put: aValue
	New way: 	aTemplate value: aValue"
	aMessage numArgs = 1 ifTrue: 
		[^ self at: aMessage selector asString onlyLetters put: aMessage argument]
	ifFalse: 
		[^ super doesNotUnderstand: aMessage].! !

!Template methodsFor: 'as yet unclassified' stamp: 'cn 12/13/2010 14:09:20.756'!
template: aString
	string := aString.! !

TestCase subclass: #AuctionHouseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-ArtworkExamples'!

!AuctionHouseTest methodsFor: 'as yet unclassified' stamp: 'cn 2/2/2011 15:05:35.312'!
testAddingArtworks
	| picasso guernica sylvette |
	picasso := Artist name: 'Picasso'.
	guernica := Artwork name: 'Guernica'.
	sylvette := Artwork name: 'Sylvette'.

	picasso addArtwork: guernica.
	picasso addArtwork: sylvette.
	picasso print.
	guernica print.! !

!AuctionHouseTest methodsFor: 'as yet unclassified' stamp: 'cn 2/2/2011 15:13:37.278'!
testArtworksMultipleArtists
	| christo jeanneclaude reichstag |
	christo := Artist name: 'Christo'.
	jeanneclaude := Artist name: 'Jeanne-Claude'.
	reichstag := Artwork name: 'Reichstag'.
	christo addArtwork: reichstag.
	jeanneclaude addArtwork: reichstag.
	christo print.
	jeanneclaude print.
	! !

!AuctionHouseTest methodsFor: 'as yet unclassified' stamp: 'cn 2/2/2011 14:19:09.217'!
testMovingArtworks
	| auctionfeb8 auctionmar12 guernica monaLisa |
	guernica := Artwork name: 'Guernica'.
	monaLisa := Artwork name: 'Mona Lisa'.
	auctionfeb8 := Auction name: '08 Feb. 2011'.
	auctionmar12 := Auction name: '12 Mar. 2011'.
	
	auctionfeb8 addArtwork: guernica.
	auctionmar12 addArtwork: monaLisa.
	
	auctionfeb8 print.
	auctionmar12 print.
	
	auctionmar12 addArtwork: guernica.
	
	auctionfeb8 print.
	auctionmar12 print.! !

TestCase subclass: #RelationshipTestManyToMany
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Tests'!

!RelationshipTestManyToMany methodsFor: 'as yet unclassified' stamp: 'cn 1/29/2011 19:05:12.593'!
setUp
	| relationship |
	relationship := ManyToManyRelationship leftClass: Parent leftClassName: 'teacher' rightClass: Child rightClassName: 'student' isBidirectional: true.
	relationship activate.! !

!RelationshipTestManyToMany methodsFor: 'as yet unclassified' stamp: 'cn 1/29/2011 19:22:04.937'!
tearDown
	| relationship |
	relationship := Parent relationships at: 'student'.
	relationship remove.! !

!RelationshipTestManyToMany methodsFor: 'as yet unclassified' stamp: 'cn 1/29/2011 14:26:22.953'!
test
	| teacher1 teacher2 student1 student2 |
	teacher1 := Parent new.
	teacher2 := Parent new.
	student1 := Child new.
	student2 := Child new.
	self should: (teacher1 students size = 0 & student1 teachers size = 0).
	teacher1 addStudent: student1; addStudent: student2.
	teacher2 addStudent: student2.
	self should: (teacher1 students size = 2 & teacher2 students size = 1).
	self should: (student2 teachers size = 2 & student1 teachers size = 1).
	teacher1 removeStudent: student1.
	self should: (teacher1 students size = 1 & teacher2 students size = 1).
	self should: (student2 teachers size = 2 & student1 teachers size = 0).! !

TestCase subclass: #RelationshipTestNoSetUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Tests'!

!RelationshipTestNoSetUp methodsFor: 'as yet unclassified' stamp: 'cn 1/6/2011 15:04:32.121'!
testWithMissingParameters	
	| result |
	"Try to create a relationship with only one class. This should fail."
	result := OneToManyRelationship new.
	result leftClass: Parent.
	"self should: raise"[result activate.] on: Error do: [^nil].
	self should: [false].! !

!RelationshipTestNoSetUp methodsFor: 'as yet unclassified' stamp: 'cn 1/29/2011 19:04:06.054'!
testWithNames	
	| relationship parent |
	"Create relationship"
	relationship := OneToManyRelationship leftClass: Parent rightClass: Child isBidirectional: true.
	relationship leftClassName: 'father'.
	relationship rightClassName: 'son'.
	relationship activate.
	"Try relationship"
	parent := Parent new.
	parent addSon: Child new.
	parent addSon: Child new.
	self should: [parent sons size = 2].
	self should: [(parent sons at: 1) father = parent].
	relationship remove.! !

TestCase subclass: #RelationshipTestOneToMany
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Tests'!

!RelationshipTestOneToMany methodsFor: 'as yet unclassified' stamp: 'cn 1/29/2011 19:19:20.527'!
setUp
	| result |
	result := OneToManyRelationship leftClass: Parent rightClass: Child isBidirectional: true.
	result activate.
	self should: ((Parent relationships at: 'child') = result).
	self should: ((Child relationships at: 'parent') = result).! !

!RelationshipTestOneToMany methodsFor: 'as yet unclassified' stamp: 'cn 1/29/2011 19:19:15.965'!
tearDown
	| relationship |
	relationship := Parent relationships at: 'child'.
	relationship remove.
	self should: ((Parent relationships at: 'child' ifAbsent: []) = nil).
	self should: ((Child relationships at: 'parent' ifAbsent: []) = nil).
	! !

!RelationshipTestOneToMany methodsFor: 'as yet unclassified' stamp: 'cn 1/29/2011 19:20:03.723'!
testGeneratedClasses
	"Tests if all methods are there"
	self should: (Parent relationships includesKey: 'child').
	self should: (Parent methodDict includesKey: ('addChild:' asSymbol) ).
	self should: (Child relationships includesKey: 'parent').
	self should: (Child methodDict includesKey: ('parent' asSymbol) ).! !

!RelationshipTestOneToMany methodsFor: 'as yet unclassified' stamp: 'cn 1/13/2011 15:26:41.778'!
testGeneratedMethodsChildAccess
	"Test the methods that have been generated on the child side"
	| parent parent2 child |
	"Create child and parent"
	child := Child new.
	parent := Parent new.
	parent2 := Parent new.
	parent addChild: child.
	self should: (child parent = parent).
	self should: ((parent childs at: 1) = child).
	"Remove parent"
	parent removeChild: child.
	self should: (child parent = nil).
	"Switch parent"
	parent addChild: child.
	self should: (child parent = parent).
	self should: ((parent childs at: 1) = child).
	parent2 addChild: child.
	self should: (child parent = parent2).
	self should: ((parent childs size) = 0).
	self should: ((parent2 childs at: 1) = child).! !

!RelationshipTestOneToMany methodsFor: 'as yet unclassified' stamp: 'cn 1/6/2011 13:33:39.967'!
testGeneratedMethodsParentAccess
	"Test the methods that have been generated on the parent side"
	| result parent child |
	"Create parent"
	parent := Parent new.
	self should: parent childs size = 0.
	"Add child to parent"
	parent addChild: Child new.
	self should: parent childs size = 1.
	child := parent childs at: 1.
	self should: (parent = child parent).
	"Getter returns copied list"
	result := parent childs.
	result remove: child.
	self should: result size = 0.
	self should: parent childs size = 1.
	"Remove child from parent"
	parent removeChild: child.
	self should: parent childs size = 0.
	self should: (child parent = nil).! !

TestCase subclass: #RelationshipTestOneToOne
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Tests'!

!RelationshipTestOneToOne methodsFor: 'as yet unclassified' stamp: 'cn 1/29/2011 19:05:03.671'!
setUp
	| relationship |
	relationship := OneToOneRelationship leftClass: Parent leftClassName: 'father' rightClass: Parent rightClassName: 'mother' isBidirectional: true.
	relationship activate.! !

!RelationshipTestOneToOne methodsFor: 'as yet unclassified' stamp: 'cn 1/29/2011 19:22:34.231'!
tearDown
	| relationship |
	relationship := Parent relationships at: 'mother'.
	relationship remove.! !

!RelationshipTestOneToOne methodsFor: 'as yet unclassified' stamp: 'cn 1/29/2011 11:34:13.824'!
test
	| father1 father2 mother1 mother2 |
	father1 := Parent new.
	mother1 := Parent new.
	father1 mother: mother1.
	self should: (father1 mother = mother1).
	self should: (mother1 father = father1).
	father1 mother: nil.
	self should: (father1 mother = nil).
	self should: (mother1 father = nil).
	mother2 := Parent new.
	father1 mother: mother1.
	father1 mother: mother2.
	self should: (father1 mother = mother2).
	self should: (mother2 father = father1).
	self should: (mother1 father = nil).
	father2 := Parent new.
	father2 mother: mother2.
	self should: (father1 mother = nil).
	self should: (father2 mother = mother2).
	self should: (mother2 father = father2).
	! !

!Class methodsFor: '*relationships' stamp: 'cn 2/2/2011 14:49:38.754'!
addRelationship: aRelationship
	"Add a relationship"
	| relationshipName |
	((aRelationship leftClass = self) or: (aRelationship rightClass = self)) ifFalse: [^ nil].
	relationships ifNil: [relationships := Dictionary new].
	relationshipName := self keyForRelationship: aRelationship.
	relationships at: relationshipName asSymbol put: aRelationship.! !

!Class methodsFor: '*relationships' stamp: 'cn 2/2/2011 14:48:05.262'!
keyForRelationship: aRelationship
	"Returns a key (or name) for this relationship that is used in the dictionary"
	((aRelationship leftClass = self) or: (aRelationship rightClass = self)) ifFalse: [^ nil].
	(aRelationship leftClass = self) ifTrue: [^ aRelationship varNameUsedInLeftClass]
		ifFalse: [^ aRelationship varNameUsedInRightClass].! !

!Class methodsFor: '*relationships' stamp: 'cn 2/2/2011 14:49:14.161'!
relationships
	"Return the dictionary of relationships"
	relationships ifNil: [relationships := Dictionary new].
	^ relationships! !

!Class methodsFor: '*relationships' stamp: 'cn 2/2/2011 14:49:25.234'!
removeRelationship: aRelationship
	"Remove the relationship"
	relationships ifNil: [relationships := Dictionary new].
	relationships removeKey: (self keyForRelationship: aRelationship).! !
